bcm53xx: fallback to default_do_upgrade if NAND upgrade fails
[openwrt/openwrt.git] / target / linux / bcm53xx / base-files / lib / upgrade / platform.sh
1 PART_NAME=firmware
2
3 # $(1): file to read magic from
4 # $(2): offset in bytes
5 get_magic_long_at() {
6 dd if="$1" skip=$2 bs=1 count=4 2>/dev/null | hexdump -v -e '1/1 "%02x"'
7 }
8
9 platform_machine() {
10 cat /proc/device-tree/compatible | tr '\0' '\t' | cut -f 1
11 }
12
13 platform_flash_type() {
14 # On NAND devices "rootfs" is UBI volume, so won't be find in /proc/mtd
15 grep -q "\"rootfs\"" /proc/mtd && {
16 echo "serial"
17 return
18 }
19
20 echo "nand"
21 }
22
23 platform_expected_image() {
24 local machine=$(platform_machine)
25
26 case "$machine" in
27 "netgear,r6250v1") echo "chk U12H245T00_NETGEAR"; return;;
28 "netgear,r6300v2") echo "chk U12H240T00_NETGEAR"; return;;
29 "netgear,r8000") echo "chk U12H315T00_NETGEAR"; return;;
30 esac
31 }
32
33 platform_identify() {
34 local magic
35
36 magic=$(get_magic_long "$1")
37 case "$magic" in
38 "48445230")
39 echo "trx"
40 return
41 ;;
42 "2a23245e")
43 echo "chk"
44 return
45 ;;
46 esac
47
48 magic=$(get_magic_long_at "$1" 14)
49 [ "$magic" = "55324e44" ] && {
50 echo "cybertan"
51 return
52 }
53
54 echo "unknown"
55 }
56
57 platform_check_image() {
58 [ "$#" -gt 1 ] && return 1
59
60 local file_type=$(platform_identify "$1")
61 local magic
62 local error=0
63
64 case "$file_type" in
65 "chk")
66 local header_len=$((0x$(get_magic_long_at "$1" 4)))
67 local board_id_len=$(($header_len - 40))
68 local board_id=$(dd if="$1" skip=40 bs=1 count=$board_id_len 2>/dev/null | hexdump -v -e '1/1 "%c"')
69 local dev_board_id=$(platform_expected_image)
70 echo "Found CHK image with device board_id $board_id"
71
72 [ -n "$dev_board_id" -a "chk $board_id" != "$dev_board_id" ] && {
73 echo "Firmware board_id doesn't match device board_id ($dev_board_id)"
74 error=1
75 }
76
77 if ! otrx check "$1" -o "$header_len"; then
78 echo "No valid TRX firmware in the CHK image"
79 error=1
80 fi
81 ;;
82 "cybertan")
83 local pattern=$(dd if="$1" bs=1 count=4 2>/dev/null | hexdump -v -e '1/1 "%c"')
84 local dev_pattern=$(platform_expected_image)
85 echo "Found CyberTAN image with device pattern: $pattern"
86
87 [ -n "$dev_pattern" -a "cybertan $pattern" != "$dev_pattern" ] && {
88 echo "Firmware pattern doesn't match device pattern ($dev_pattern)"
89 error=1
90 }
91
92 if ! otrx check "$1" -o 32; then
93 echo "No valid TRX firmware in the CyberTAN image"
94 error=1
95 fi
96 ;;
97 "trx")
98 if ! otrx check "$1"; then
99 echo "Invalid (corrupted?) TRX firmware"
100 error=1
101 fi
102 ;;
103 *)
104 echo "Invalid image type. Please use only .trx files"
105 error=1
106 ;;
107 esac
108
109 return $error
110 }
111
112 platform_pre_upgrade() {
113 local file_type=$(platform_identify "$1")
114 local dir="/tmp/sysupgrade-bcm53xx"
115 local trx="$1"
116 local offset
117
118 [ "$(platform_flash_type)" != "nand" ] && return
119
120 # Find trx offset
121 case "$file_type" in
122 "chk") offset=$((0x$(get_magic_long_at "$1" 4)));;
123 "cybertan") offset=32;;
124 esac
125
126 # Extract partitions from trx
127 rm -fR $dir
128 mkdir -p $dir
129 otrx extract "$trx" \
130 ${offset:+-o $offset} \
131 -1 $dir/kernel \
132 -2 $dir/root
133 [ $? -ne 0 ] && {
134 echo "Failed to extract TRX partitions."
135 return
136 }
137
138 # Firmwares without UBI image should be flashed "normally"
139 local root_type=$(identify $dir/root)
140 [ "$root_type" != "ubi" ] && {
141 echo "Provided firmware doesn't use UBI for rootfs."
142 return
143 }
144
145 # Prepare TRX file with just a kernel that will replace current one
146 local linux_length=$(grep "\"linux\"" /proc/mtd | sed "s/mtd[0-9]*:[ \t]*\([^ \t]*\).*/\1/")
147 [ -z "$linux_length" ] && {
148 echo "Unable to find \"linux\" partition size"
149 exit 1
150 }
151 linux_length=$((0x$linux_length))
152 local kernel_length=$(wc -c $dir/kernel | cut -d ' ' -f 1)
153 [ $kernel_length -gt $linux_length ] && {
154 echo "New kernel doesn't fit \"linux\" partition."
155 return
156 }
157 rm -f /tmp/null.bin
158 rm -f /tmp/kernel.trx
159 touch /tmp/null.bin
160 otrx create /tmp/kernel.trx \
161 -f $dir/kernel -b $(($linux_length + 28)) \
162 -f /tmp/null.bin
163 [ $? -ne 0 ] && {
164 echo "Failed to create simple TRX with new kernel."
165 return
166 }
167
168 # Prepare UBI image (drop unwanted extra blocks)
169 local ubi_length=0
170 while [ "$(dd if=$dir/root skip=$ubi_length bs=1 count=4 2>/dev/null)" = "UBI#" ]; do
171 ubi_length=$(($ubi_length + 131072))
172 done
173 dd if=$dir/root of=/tmp/root.ubi bs=131072 count=$((ubi_length / 131072)) 2>/dev/null
174 [ $? -ne 0 ] && {
175 echo "Failed to prepare new UBI image."
176 return
177 }
178
179 # Flash
180 mtd write /tmp/kernel.trx firmware
181 nand_do_upgrade /tmp/root.ubi
182 }
183
184 platform_trx_from_chk_cmd() {
185 local header_len=$((0x$(get_magic_long_at "$1" 4)))
186
187 echo -n dd bs=$header_len skip=1
188 }
189
190 platform_trx_from_cybertan_cmd() {
191 echo -n dd bs=32 skip=1
192 }
193
194 platform_do_upgrade() {
195 local file_type=$(platform_identify "$1")
196 local trx="$1"
197 local cmd=
198
199 [ "$(platform_flash_type)" == "nand" ] && {
200 echo "Writing whole image to NAND flash. All erase counters will be lost."
201 }
202
203 case "$file_type" in
204 "chk") cmd=$(platform_trx_from_chk_cmd "$trx");;
205 "cybertan") cmd=$(platform_trx_from_cybertan_cmd "$trx");;
206 esac
207
208 default_do_upgrade "$trx" "$cmd"
209 }